﻿using System;
using System.Collections.Generic;
using System.Drawing;

namespace i384
{
    public class Edge
    {
        public int StartingVertex { get; set; }

        public int EndingVertex { get; set; }

        public bool Directed { get; set; }

        public void Draw(Graphics graphics, List<Vertex> vertices)
        {
            Edge.Draw(graphics, vertices[this.StartingVertex], vertices[this.EndingVertex], this.Directed);
        }

        public static void Draw(Graphics graphics, Vertex startingVertex, Vertex endingVertex, bool directed)
        {
            Vector2 startingCircleMiddle = startingVertex.Position + DrawingSettings.CircleSize / 2;
            Vector2 endingCircleMiddle = endingVertex.Position + DrawingSettings.CircleSize / 2;

            Vector2 direction = (endingCircleMiddle - startingCircleMiddle).DirectionUnit;

            Vector2 startingPoint = startingCircleMiddle + ((DrawingSettings.CircleSize / 2) * direction);
            Vector2 endingPoint = endingCircleMiddle - ((DrawingSettings.CircleSize / 2) * direction);

            graphics.DrawLine(DrawingSettings.Black, startingPoint, endingPoint);

            if (directed)
            {
                int length = 20;

                Vector2 arrowLeftLine = (((-direction).DirectionUnit) * length).Rotate(0.5f);
                Vector2 arrowRightLine = (((-direction).DirectionUnit) * length).Rotate(-0.5f);

                graphics.DrawLine(DrawingSettings.Black, endingPoint, endingPoint + arrowLeftLine);
                graphics.DrawLine(DrawingSettings.Black, endingPoint, endingPoint + arrowRightLine);
            }
        }
    }
}